Attribute VB_Name = "modAnlagenSpeichernWeiterleiten"
Option Explicit
' Buch "Selbstorganisation und Zeitmanagement mit MS Outlook" (Stobbe, Wuttke, 2016, mitp)
' Autor: Irina Stobbe, 2016
' nur "as it is" - ohne Garantie

Const strTITEL        As String = "Anlagen speichern und Nachricht darber sichern oder weiterleiten"
Const strAUSGANGSPFAD As String = "H:\\Anwender"        ' Pfadauswahl kann nicht die Laufwerke wechseln'  
Const PR_ATT_CONTENT_ID As String = "http://schemas.microsoft.com/mapi/proptag/0x3712001E"   ' verschiedene Benennungen gefunden

' Verwendete Enumerationen (https://msdn.microsoft.com/de-de/library/office, 07/2016)
' olAttachmentType:
'  olByReference = 4 - This value is no longer supported since Microsoft Outlook 2007. Use olByValue to attach a copy of a file in the file system.
'  olByValue = 1 - The attachment is a copy of the original file and can be accessed even if the original file is removed.
'  olEmbeddeditem = 5 - the attachment is an Outlook message format file (.msg) and is a copy of the original message.
'  olOLE = 6 - The attachment is an OLE document.
' olBodyFormat:
'  olFormatHTML =2 -  HTML Format
'  olFormatPlain = 1 - Plain Format
'  olFormatRichText = 3 - Rich text format
'  olFormatUnspecified= 0 - Unspecified Format
 
' Hinweis:
' Das Wort "Anlage" wird in dem eingefgten Text nicht verwendet,
' damit Anlagen-Test-Makros auf diesen Begriff nicht anspringen und nach etwa fehlenden Anlagen fragen


Sub AnlagenSpeichernLinkWeiterleiten()
    Dim olApp As Outlook.Application
    Dim fMailFolder As Outlook.Folder
    Dim exMailExplorer As Outlook.Explorer
    Dim oSelectedMail As Outlook.MailItem
    
    Dim intHatAnlagen As Integer        ' Anzahl der Anlagen, 0= keine Anlagen
    Dim lstAnlagen() As String          ' DateiNamen und andere Eigenschaften der Anlagen
    Dim i As Integer, j As Integer
    
    
    intHatAnlagen = 0
   
    Set olApp = GetObject(, "Outlook.Application")
    ' Aktueller Ordner
    Set exMailExplorer = Application.ActiveExplorer
    
    If exMailExplorer.Selection.Count > 0 Then
      For i = 1 To exMailExplorer.Selection.Count
        Set oSelectedMail = exMailExplorer.Selection(i)        ' selected sollte nur eine sein
       
        ' Anlagen erfassen
        Call AnlagenErfassen(oSelectedMail, lstAnlagen, intHatAnlagen)
        
        ' Anlagen speichern und lschen
        ' Liste der Anlagenspeicherpfade in den Email-Text schreiben
        Call AnlagenSpeichernLoeschen(oSelectedMail, lstAnlagen, intHatAnlagen)

        ' E-Mail speichern oder weiterleiten
        ' Liste der gespeicherten Anlagen einfgen
        Call EMailErweiternSpeichernSenden(oSelectedMail, lstAnlagen, intHatAnlagen)
        
      Next i
    Else
        MsgBox "Keine E-Mail wurde markiert"
    End If ' selection.count
    ' Aufrumen
    Set oSelectedMail = Nothing
    Set exMailExplorer = Nothing: Set fMailFolder = Nothing
    Set olApp = Nothing
End Sub
    
    

Sub AnlagenErfassen(oSelectedMail As MailItem, lstAnlagen() As String, nAnz As Integer)
    
    Dim i As Integer
    Dim att As Attachment
    Dim oPA As Outlook.propertyAccessor
    Dim strProp As String
    Dim msg As String, booAuswahl As Boolean

    i = 0
    nAnz = oSelectedMail.Attachments.Count
    On Error Resume Next    ' bestimmte Anlagen bekommn keine Properties, mit "false" weiter zum speichern
    strProp = ""
    
    For Each att In oSelectedMail.Attachments
      
        Select Case oSelectedMail.BodyFormat
        Case olFormatHTML
            strProp = False
            ' Bei HTML haben das eingebettete Bild, eine Worddatei und csv-Dateien eine bestimmte <>"" Eigenschaft
            Set oPA = att.propertyAccessor
            ' ndert sich die Eigenschaft oder gibt es einen Fehler
            strProp = oPA.GetProperty(PR_ATT_CONTENT_ID)
            ' keine echte Anlage
            booAuswahl = Not (strProp = "") And Left(att.DisplayName, 5) = "image"
        Case olFormatRichText
            ' Eingebettetes Bild ist vom Typ olOLE
            booAuswahl = (att.Type = olOLE)
        Case olFormatPlain
            ' kein eingebettetes Bild mglich
            booAuswahl = False
        Case Else
           MsgBox "E-Mail ist vom Typ " & oSelectedMail.BodyFormat & " wird gespeichert"
           booAuswahl = True
        End Select ' olHTML
        
        If booAuswahl Then
            MsgBox att.DisplayName & " verbleibt" & vbLf & "***" & strProp & "***"
            nAnz = nAnz - 1

        Else
            i = i + 1  ' Anlagen in der Liste sammeln
            ReDim Preserve lstAnlagen(1 To 4, 1 To i)
            With att
              lstAnlagen(1, i) = .DisplayName
              lstAnlagen(2, i) = .FileName
              lstAnlagen(3, i) = oSelectedMail.BodyFormat & vbLf & "***" & strProp & "***"
              lstAnlagen(4, i) = .PathName
              msg = msg & .FileName & vbLf
            End With
        End If ' Property
    Next att
    On Error GoTo 0

    If Len(msg) = 0 Then msg = "Kein Dokument ist zu speichern"
    MsgBox nAnz & " Dokument(e) erfasst" & vbLf & msg, , strTITEL
    ' Aufrumen
    Set oPA = Nothing: Set att = Nothing
End Sub


Sub AnlagenSpeichernLoeschen(oSelectedMail As MailItem, lstAnlagen() As String, nAnz As Integer)
    Dim i As Integer, varReturn As Integer, msg As String, strAnlagenName As String, str As String, strStart As String
    
    strStart = strAUSGANGSPFAD		' Alternative = "C:" & Environ("HOMEPATH") & "\Documents"
    
    For i = nAnz To 1 Step -1
        'lstAnlagen(1, i) = InputBox("Wohin speichern?", strTitel, "C:" & Environ("HOMEPATH") & "\Documents\Tests")  ' .\Anlagen")
        str = PfadAuswaehlen(("In welchen Ordner soll " & lstAnlagen(2, i) & " gespeichert werden?"), strStart)
        If str = "" Then
            MsgBox "Sie haben keinen Speicherpfad gewhlt! (Abbruch)"
            Exit Sub
        Else
            lstAnlagen(1, i) = str
            strStart = str
        End If
        
        strAnlagenName = str & "\" & lstAnlagen(2, i)
        
        On Error Resume Next
        varReturn = True
        ' Jetzt speichern:
        oSelectedMail.Attachments(lstAnlagen(2, i)).SaveAsFile (strAnlagenName)
        If Err.Number > 0 Then varReturn = False
        On Error GoTo 0: Err = 0
        ' Nach erfolgreicher Speicherung lschen
        If varReturn Then
            oSelectedMail.Attachments(lstAnlagen(2, i)).Delete
            ' neuen Speicherpfad auslesen und in die Liste nach 1 schreiben
            msg = msg & strAnlagenName & "- erfolgreich" & vbLf
            lstAnlagen(1, i) = strAnlagenName
        Else
        ' nicht lschen, speichern ging schief
            nAnz = nAnz - 1
            msg = msg & strAnlagenName & "- Fehler" & vbLf
        End If
    Next i
    If msg = "" Then msg = "Nichts"
    MsgBox "Gespeichert und aus der E-Mail gelscht: " & vbLf & msg, vbOKOnly, strTITEL
    Exit Sub
FB_AnlagenSpeichern:
    Select Case MsgBox("Datei konnte nicht gespeichert werden! " & vbLf & _
        Err.Number & ": " & Err.Description & vbLf, _
        vbAbortRetryIgnore + vbCritical + vbDefaultButton2, strTITEL)
    Case vbAbort
    Case vbRetry
        Stop: Resume 0
    Case vbIgnore
        varReturn = False
        Resume Next
    End Select
End Sub

Sub EMailErweiternSpeichernSenden(oSelectedMail As MailItem, lstAnlagen() As String, nAnz As Integer)
    Dim oForwardedMail As Outlook.MailItem
        
        
        Select Case MsgBox("Nur Speichern oder Weiterleiten?" & vbLf & _
            "Ja = Speicherndialog," & vbLf & "Nein = Weiterleiten, " & vbLf & "Abbrechen = Nichts passiert mehr", _
            vbYesNoCancel + vbQuestion + vbDefaultButton2, strTITEL)
        Case vbYes
            ' kommentiert im Postfach speichern
            If oSelectedMail.BodyFormat = olFormatHTML Then
                oSelectedMail.HTMLBody = BodyErweiternHTML(oSelectedMail, lstAnlagen, nAnz) & oSelectedMail.HTMLBody
            Else
                'oSelectedMail.body = BodyErweiternText(oSelectedMail, lstAnlagen, nAnz) & oSelectedMail.body
                ' zwangsweise umwandeln in HTML, damit die Verlinkung klappt
                oSelectedMail.BodyFormat = olFormatHTML
                oSelectedMail.HTMLBody = BodyErweiternHTML(oSelectedMail, lstAnlagen, nAnz) & oSelectedMail.body
            End If
            ' Signatur "Leer" anfgen (sollte wenigstens den Namen desjenigen enthalten, der speichert)
            oSelectedMail.HTMLBody = oSelectedMail.HTMLBody & GetSigText(olFormatHTML, "Leer")
            oSelectedMail.Save
            
       Case vbNo
            ' Weiterleiten
            ' erst anzeigen? Muss im Inspector bearbeitet werden (zB Adressen eingeben)
            Set oForwardedMail = oSelectedMail.Forward
            oForwardedMail.Display
            
            If oForwardedMail.BodyFormat = olFormatHTML Then
                oForwardedMail.HTMLBody = BodyErweiternHTML(oSelectedMail, lstAnlagen, nAnz) & oForwardedMail.HTMLBody
            Else
                'oForwardedMail.body = BodyErweiternText(oSelectedMail, lstAnlagen, nAnz) & oForwardedMail.body
                oForwardedMail.BodyFormat = olFormatHTML
                oForwardedMail.HTMLBody = BodyErweiternHTML(oSelectedMail, lstAnlagen, nAnz) & oForwardedMail.body
            End If
            oForwardedMail.HTMLBody = oForwardedMail.HTMLBody & GetSigText(olFormatHTML, "Gre")
            
            
        Case Else ' vbAbort
            'MsgBox "Keine weitere Aktion"
        End Select ' Speichern oder Weiterleiten
    ' Aufrumen
    Set oForwardedMail = Nothing
End Sub

Function BodyErweiternText(oSelectedMail As MailItem, lstAnlagen() As String, nAnz As Integer) As String

    Dim strText As String
    Dim strListe As String, i As Integer, n As Integer
    
    strText = "Die folgenden Dokumente wurden gespeichert: " & vbLf & vbLf
    ' ohne HTML
    If nAnz = 0 Then
        strListe = "keine" & vbLf
    Else   ' n >0
        For i = 1 To nAnz
             strListe = strListe & i & ": " & "file:\" & lstAnlagen(1, i) & vbLf
        Next i
    End If
    strListe = strListe & vbLf
    BodyErweiternText = strText & strListe
    
End Function

Function BodyErweiternHTML(oSelectedMail As MailItem, lstAnlagen() As String, nAnz As Integer) As String

    Dim strText As String
    Dim strListe As String, i As Integer, n As Integer
    
    strText = "Die folgenden Dokumente wurden gespeichert: <br/><br/> "
    ' mit HTML
    If nAnz = 0 Then
        strListe = "keine<br/>"
    Else   ' nAnz >0
        For i = 1 To nAnz
             strListe = strListe & i & ": <a href=""file:///" & _
                lstAnlagen(1, i) & _
                """>" & lstAnlagen(1, i) & " </a><br/>"
        Next i
    End If
    BodyErweiternHTML = "<font color=red>" & strText & strListe & "<br/></font>"
    Debug.Print BodyErweiternHTML
End Function

