Attribute VB_Name = "modSerientermine"
Option Explicit

' Buch "Selbstorganisation und Zeitmanagement mit MS Outlook" (Stobbe, Wuttke, 2016, mitp)
' Autor: Irina Stobbe, 2016
' nur "as it is" - ohne Garantie

'Interner Name der Makrolsung fr die Fenstertitel
Private Const DLGTITLE As String = "Serientermine ergnzen"
Public AnzahlST As Integer


Sub WiederholungstageEinrichten1(objAppointItem As AppointmentItem)
    ' Mit Inputfenster-Dialog
    Dim Eingabe As Variant
    Dim Anzahl As Integer
    Dim strSubject As String, dtStart As Date
    Dim myRecurrPatt As RecurrencePattern
    
    Eingabe = InputBox("Wieviel Tage insgesamt? (1 bis 5)", DLGTITLE, 1)
    If "" = Eingabe Then Exit Sub
    If Not IsNumeric(Eingabe) Then Exit Sub
    ' Nur fr 1 bis 5 Tage (Woche)
    Anzahl = IIf(Eingabe <= 1, 1, IIf(Eingabe > 5, 5, Eingabe))
       
    strSubject = objAppointItem.Subject
    dtStart = objAppointItem.Start
    ' vorige Muster lschen
    objAppointItem.ClearRecurrencePattern
    If Anzahl > 1 Then      ' Kein neues Muster setzen bei 1
        Set myRecurrPatt = objAppointItem.GetRecurrencePattern
        myRecurrPatt.RecurrenceType = olRecursDaily
        myRecurrPatt.PatternStartDate = dtStart   ' Uhrzeiten wie in der Vorgabe
        myRecurrPatt.PatternEndDate = DateAdd("d", CDbl(Anzahl - 1), dtStart)
    End If
    objAppointItem.Save
    
    objAppointItem.ReminderSet = True
    objAppointItem.ReminderMinutesBeforeStart = 720
    
End Sub


Sub WiederholungstageEinrichten(objAppointItem As AppointmentItem)
    ' Nach Festlegung der Tagesanzahl mit Dialogformular 
    Dim strSubject As String, dtStart As Date
    Dim myRecurrPatt As RecurrencePattern
    
    strSubject = objAppointItem.Subject
    dtStart = objAppointItem.Start
    ' vorige Muster lschen
    objAppointItem.ClearRecurrencePattern
    If AnzahlST > 1 Then      ' Kein neues Muster setzen bei 1, globale Variable
        Set myRecurrPatt = objAppointItem.GetRecurrencePattern
        myRecurrPatt.RecurrenceType = olRecursDaily
        myRecurrPatt.PatternStartDate = dtStart   ' Uhrzeiten wie in der Vorgabe
        myRecurrPatt.PatternEndDate = DateAdd("d", CDbl(AnzahlST - 1), dtStart)
    End If
    objAppointItem.Save
    
    objAppointItem.ReminderSet = True
    objAppointItem.ReminderMinutesBeforeStart = 720
End Sub

